from wwww import ent_id
from unifile import UnicodeFile
import locale, os.path, sys

def WriteToc(b, dest):
    "generate table of comments and topic summary for weblog -> /contents.html (/site/contents.txt)"

    while dest.startswith('/'):
        dest = dest[1:]
    d = b.details
    dfn = os.path.join(d.authPath, 'site', dest)
    durl = dest.replace('\\', '/')
    if durl.endswith('.txt'):
        durl = durl[:-4] + '.html'
    d.topicPageUrl = durl
    
    print "Writing table of contents to %s" % dfn
    print "\tthe url will be %s" % b.GetTopicsUrl()
    d.WriteCache()

    f = UnicodeFile(dfn, 'wt')

    print>>f, "%title", "%s: table of contents" % b.GetTitle()

    topics = {}

    def postlink(post):
        return '<a href="%s">%s</a>' % (post.GetUrl(), post.GetTitle())

    def getmonthname(num):
        if hasattr(locale, 'nl_langinfo'):
            return locale.nl_langinfo(locale.MON_1 + num)
        return ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"][num]

    for year in b.years:
        #print year
        for month in year.months:
            #print "\t",month
            print>>f, "\n%s, %04d" % (getmonthname(month.number - 1), year.number)
            print>>f, '<div class="TOCmonth">'
            for day in month.days:
                #print "\t\t",day
                for post in day.posts:
                    #print "\t\t\t",post['title'],post.GetUrl()
                    post_topics = post.GetLocalTopics()
                    if post_topics:
                        for topic,topicurl in post_topics:
                            eid = ent_id(topic)
                            #print topic, eid
                            topics.setdefault(eid, {'name': topic, 'posts': []})['posts'].append(post)
                        topic_html = ' (%s)' % ', '.join(['<i>%s</i>' % topic for topic,topicurl in post_topics])
                    else:
                        topic_html = ''
                    print>>f, '%d &#8212; %s%s' % (day.number, postlink(post), topic_html)
            print>>f, "</div>"

    print>>f, '\n<h3><a name="topics">Topics</a></h3>'
    topics = topics.items()
    topics.sort()
    for eid, topic in topics:
        print>>f, '<a name="t_%s"></a>topic: <a href="%s"><b>%s</b></a>' % (eid, b.GetTopicUrl(eid), topic['name'])
        print>>f, '<div class="TOCtopicposts">'
        for post in topic['posts']:
            print>>f, "%s &#8212; %s" % (post.DateStr(), postlink(post))
        print>>f, '</div>\n'
        

    f.close()

def show_topics(b):
    topics = {}
    for year in b.years:
        for month in year.months:
            for day in month.days:
                for post in day.posts:
                    for topid,topurl in post.GetLocalTopics():
                        topics[topid] = topics.setdefault(topid, 0) + 1
    counts = topics.items()
    counts.sort()
    for topid,count in counts:
        print count,topid
